## toil 8.2.0

=== Makefile ===
# Copyright (C) 2015-2021 Regents of the University of California
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
include common.mk

define help

Supported targets: prepare, develop, docs, dist, clean, test, docker, and push_docker.

Please note that all build targets require a virtualenv to be active.

The 'prepare' target installs Toil's build requirements into the current virtualenv.

The 'develop' target creates an editable install of Toil and its runtime requirements in the
current virtualenv. The install is called 'editable' because changes to the source code
immediately affect the virtualenv. Set the 'extras' variable to ensure that the 'develop' target
installs support for extras; some tests require extras to be installed. Consult setup.py for the
list of supported extras. To install Toil in develop mode with all extras, run

	make develop extras=[all]

The 'dist' target creates a source distribution and a wheel of Toil. It is used
for some unit tests and for installing the currently checked out version of Toil
into the appliance image.

The 'clean' target cleans up the side effects of 'develop', 'dist', 'docs', and 'docker'
on this machine. It does not undo externally visible effects like removing packages already
uploaded to PyPI.

The 'docs' target uses Sphinx to create HTML documentation in the docs/_build directory

Targets are provided to run Toil's tests. Note that these targets do *not* automatically install
Toil's dependencies; it is recommended to 'make develop' before running any of them.

The 'test' target runs Toil's unit tests in parallel with pytest. It will run some docker tests and
setup. Note: this target does not capture output from the terminal. For any of the test targets,
set the 'tests' variable to run a particular test, e.g.

	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
    
The 'cov' variable can be set to '' to suppress the test coverage report.
    
The 'test_offline' target is similar, but runs only tests that don't need
Internet or Docker by default.  The 'test_offline' target takes the same
arguments as the 'test' target.

    make test_offline tests=src/toil/test/src/threadingTest.py

The 'docker' target builds the Docker images that make up the Toil appliance. You may set the
TOIL_DOCKER_REGISTRY variable to override the default registry that the 'push_docker' target pushes
the appliance images to, for example:

	TOIL_DOCKER_REGISTRY=quay.io/USER make docker

You might also want to build just for one architecture and load into your
Docker daemon. We have a 'load_docker' target for this.

    make load_docker arch=amd64

If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.

The 'push_docker' target pushes the Toil appliance images to a remote Docker registry. It
requires the TOIL_DOCKER_REGISTRY variable to be set to a value other than the default to avoid
accidentally pushing to the official Docker registry for Toil.

The TOIL_DOCKER_NAME environment variable can be set to customize the appliance image name that
is created by the 'docker' target and pushed by the 'push_docker' target.

endef
export help
help:
	@printf "$$help"


# This Makefile uses bash features like printf and <()
SHELL=bash
tests=src/toil/test
arch=linux/amd64,linux/arm64
cov=--cov=toil
logging=--log-format="%(asctime)s %(levelname)s %(message)s" --log-level DEBUG -o log_cli=true --log-cli-level INFO
verbose=-vv
durations=--durations=0
extras=
# You can say make develop packages=xxx to install packages in the same Python
# environment as Toil itself without creating dependency conflicts with Toil
packages=
sdist_name:=toil-$(shell python3 version_template.py distVersion).tar.gz

green=\033[0;32m
normal=\033[0m
red=\033[0;31m
cyan=\033[0;36m

# expression to tell pytest what tests to run based on their marks
# the empty string means all tests will be run
marker=""
# Number of tests to run in parallel.
threads:="auto"

dist:="worksteal"
pytest_args:=""

# Only pass the threading options if running parallel tests. Otherwise we lose
# live logging. See <https://stackoverflow.com/q/62533239>
ifeq "$(threads)" "auto"
	threadopts=-n $(threads) --dist $(dist)
else
ifeq "$(threads)" "1"
	threadopts=
else
	threadopts=-n $(threads) --dist $(dist)
endif
endif

develop: check_venv
	python3 setup.py check
	pip install -e .$(extras) $(packages)

clean_develop: check_venv
	- rm -rf src/*.egg-info
	- rm src/toil/version.py

uninstall:
	- pip uninstall -y toil

dist: sdist
sdist: dist/$(sdist_name)

dist/$(sdist_name):
	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
	python3 -m build
	@test -f dist/$(sdist_name).old \
	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
	         && printf "$(cyan)No significant changes to sdist, reinstating backup.$(normal)\n" \
	         || rm dist/$(sdist_name).old ) \
	    || true

clean_sdist:
	- rm -rf dist
	- rm src/toil/version.py

download_cwl_spec:
	git clone https://github.com/common-workflow-language/cwl-v1.2.git src/toil/test/cwl/spec_v12 || true && cd src/toil/test/cwl/spec_v12 && git checkout 0d538a0dbc5518f3c6083ce4571926f65cb84f76
	git clone https://github.com/common-workflow-language/cwl-v1.1.git src/toil/test/cwl/spec_v11 || true && cd src/toil/test/cwl/spec_v11 && git checkout 664835e83eb5e57eee18a04ce7b05fb9d70d77b7
	git clone https://github.com/common-workflow-language/common-workflow-language.git src/toil/test/cwl/spec || true && cd src/toil/test/cwl/spec && git checkout 6a955874ade22080b8ef962b4e0d6e408112c1ef
	# Add .cwltest to filenames so the Pytest plugin can see them
	cp src/toil/test/cwl/spec_v12/conformance_tests.yaml src/toil/test/cwl/spec_v12/conformance_tests.cwltest.yaml
	cp src/toil/test/cwl/spec_v11/conformance_tests.yaml src/toil/test/cwl/spec_v11/conformance_tests.cwltest.yaml
	cp src/toil/test/cwl/spec/v1.0/conformance_test_v1.0.yaml src/toil/test/cwl/spec/v1.0/conformance_test_v1.0.cwltest.yaml


### pytest options, see also setup.cfg, section "[tool:pytest]" (which can be overriden using 'pytest_args=--color=no' or similar)

# Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
test: check_venv check_build_reqs
	TOIL_OWNER_TAG="shared" \
	TOIL_HISTORY=0 \
	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(cov) $(tests) $(pytest_args)

test_debug: check_venv check_build_reqs
	TOIL_OWNER_TAG="$(whoami)" \
	TOIL_HISTORY=0 \
	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(tests) $(pytest_args) --maxfail=1


# This target will skip building docker and all docker based tests
# these are our travis tests; rename?
test_offline: check_venv check_build_reqs
	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
	TOIL_SKIP_DOCKER=True \
	TOIL_SKIP_ONLINE=True \
	TOIL_HISTORY=0 \
	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(cov) $(tests) $(pytest_args)

# This target will run about 1 minute of tests, and stop at the first failure
test_1min: check_venv check_build_reqs
	TOIL_SKIP_DOCKER=True \
	TOIL_HISTORY=0 \
	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) --timeout=10  --maxfail=1 $(pytest_args) src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::TestCWLWorkflow::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior

ifdef TOIL_DOCKER_REGISTRY

docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)
grafana_image:=$(TOIL_DOCKER_REGISTRY)/toil-grafana
prometheus_image:=$(TOIL_DOCKER_REGISTRY)/toil-prometheus
mtail_image:=$(TOIL_DOCKER_REGISTRY)/toil-mtail

define tag_docker
	@printf "$(cyan)Removing old tag $2. This may fail but that's expected.$(normal)\n"
	-docker rmi $2
	docker tag $1 $2
	@printf "$(green)Tagged appliance image $1 as $2.$(normal)\n"
endef

docker: toil_docker prometheus_docker grafana_docker mtail_docker

toil_docker: docker/Dockerfile
	mkdir -p .docker_cache
	@set -ex \
	; cd docker \
	; docker buildx build --platform=$(arch) --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=local,dest=../.docker-cache/toil -f Dockerfile .

prometheus_docker:
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/prometheus \
	; docker buildx build --platform=$(arch) --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=local,dest=../../.docker-cache/prometheus -f Dockerfile .

grafana_docker:
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/grafana \
	; docker buildx build --platform=$(arch) --tag=$(grafana_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/grafana --cache-to type=local,dest=../../.docker-cache/grafana -f Dockerfile .

mtail_docker:
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/mtail \
	; docker buildx build --platform=$(arch) --tag=$(mtail_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(mtail_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(mtail_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/mtail --cache-to type=local,dest=../../.docker-cache/mtail -f Dockerfile .

docker/$(sdist_name): dist/$(sdist_name)
	cp $< $@

docker/Dockerfile: docker/Dockerfile.py docker/$(sdist_name)
	_TOIL_SDIST_NAME=$(sdist_name) python docker/Dockerfile.py > $@

clean_docker:
	-rm docker/Dockerfile docker/$(sdist_name)
	-docker rmi $(docker_image):$(TOIL_DOCKER_TAG)

push_docker: docker
	# Weird if logic is so we fail if all the pushes fail.
	# We need to build from the local cache to the cache tag and again from the local cache to the real tag.
	cd docker ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=inline -f Dockerfile . && \
			docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile . && \
			break || sleep 60; \
	done
	cd dashboard/prometheus ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=inline -f Dockerfile . && \

=== requirements.txt ===
dill>=0.3.2, <0.4
requests<=2.31.0
docker>=6.1.0, <8
urllib3>=1.26.0,<3
python-dateutil
psutil >= 6.1.0, < 8
PyPubSub >=4.0.3, <5
addict>=2.2.1, <2.5
backports.zoneinfo[tzdata];python_version<"3.9"
enlighten>=1.5.2, <2
configargparse>=1.7,<2
ruamel.yaml>=0.15
pyyaml>=6,<7
typing-extensions>=4.6.2, <5
coloredlogs>=15,<16
prompt_toolkit>=3.0,<4

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -W --keep-going
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile clean

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

clean:
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	rm -rf autoapi

=== debian/changelog ===
toil (8.2.0-1) unstable; urgency=medium

  * New upstream version.
        Fixed slurm partition selection
        Cleanup of unneeded files
        Improve Google Cloud authentication errors
        Caching support for CWL
        Add `--slurmPartition` and `--slurmGPUPartition` and support `--time`
          in `TOIL_SLURM_ARGS`
  * Standards-Version: 4.7.2 (routine-update)
  * Refreshed patches. Dropped 3 that are not longer needed
  * d/control: include cwltest, python3-pytest-timeout,
               python3-pytest-subtests, and python3-prompt-toolkit
  * Added patch to fix typos

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 30 Sep 2025 15:15:12 +0200

=== debian/control ===
Source: toil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               python3-all:any,
               python3-setuptools,
               python3-setuptools-scm,
               python3-configargparse,
               python3-docker,
               python3-dill,
               cwltool (>= 3.1.20240112164112),
               python3-schema-salad (>= 8.4.20230128170514),
               python3-enlighten,
               python3-wdlparse,
               python3-pytest <!nocheck>,
               python3-pytest-xdist <!nocheck>,
               python3-boto3 (>=1.17) <!nocheck>,
               python3-stubserver <!nocheck>,
               rsync <!nocheck>,
               python3-yaml <!nocheck>,
               docker.io <!nocheck>,
               python3-urllib3,
               cwltool-doc <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-autoapi <!nodoc>,
               python3-sphinx-autodoc-typehints <!nodoc>,
               python3-sphinxcontrib.autoprogram <!nodoc>,
               python3-pubsub <!nodoc>,
               python3-doc <!nodoc>,
               python3-tz <!nodoc> <!nocheck>,
               cwl-utils <!nocheck>,
               cwltest <!nocheck>,
               python3-pytest-timeout <!nocheck>,
               python3-pytest-subtests <!nocheck>,
               python3-prompt-toolkit <!nocheck>
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/toil
Vcs-Git: https://salsa.debian.org/med-team/toil.git
Homepage: https://github.com/BD2KGenomics/toil
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: toil
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         cwltool (>= 3.1.20240112164112),
         python3-schema-salad (>= 8.4.20230128170514),
         python3-boto3
Recommends: python3-libcloud
# for mesos support, but needs python3-mesos first
#           python3-protobuf,
Suggests: podman | docker.io | singularity-container | docker-ce,
          python3-idna,
Provides: cwl-runner
#Suggests: python-toil-doc
Description: cross-platform workflow engine
 Toil is a scalable, efficient, cross-platform and easy-to-use workflow
 engine in pure Python.  It works with several well established load
 balancers like Slurm or the Sun Grid Engine.  Toil is also compatible with
 the Common Workflow Language (CWL) via the "toil-cwl-runner" interface, which
 this package make available via the Debian alternativess system under the
 alias "cwl-runner".

#Package: python-toil-doc
#Architecture: all
#Section: doc
#Depends: ${sphinxdoc:Depends}, ${misc:Depends}
#Description: cross-platform workflow engine (common documentation)
# The documentation of Toil shall go here at some point.
# .
# This is the common documentation package.

=== debian/tests/control ===
Tests: smoke-test
Depends: @
Restrictions: allow-stderr, superficial

## toil 9.0.0

=== Makefile ===
--- 
+++ 
@@ -65,7 +65,7 @@
 You might also want to build just for one architecture and load into your
 Docker daemon. We have a 'load_docker' target for this.
 
-    make load_docker arch=amd64
+    make load_docker arch=linux/amd64
 
 If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
 same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.
@@ -129,7 +129,7 @@
 
 clean_develop: check_venv
 	- rm -rf src/*.egg-info
-	- rm src/toil/version.py
+	- rm -f src/toil/version.py
 
 uninstall:
 	- pip uninstall -y toil
@@ -149,7 +149,7 @@
 
 clean_sdist:
 	- rm -rf dist
-	- rm src/toil/version.py
+	- rm -f src/toil/version.py
 
 download_cwl_spec:
 	git clone https://github.com/common-workflow-language/cwl-v1.2.git src/toil/test/cwl/spec_v12 || true && cd src/toil/test/cwl/spec_v12 && git checkout 0d538a0dbc5518f3c6083ce4571926f65cb84f76
@@ -184,11 +184,12 @@
 	TOIL_HISTORY=0 \
 	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(cov) $(tests) $(pytest_args)
 
-# This target will run about 1 minute of tests, and stop at the first failure
+# This target will run about 1 minute of tests, and stop at the first failure.
+# There can be more than one failure because of parallel execution.
 test_1min: check_venv check_build_reqs
-	TOIL_SKIP_DOCKER=True \
-	TOIL_HISTORY=0 \
-	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) --timeout=10  --maxfail=1 $(pytest_args) src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::TestCWLWorkflow::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior
+	TOIL_SKIP_DOCKER=False \
+	TOIL_HISTORY=0 \
+	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) --timeout=30  --maxfail=1 $(pytest_args) src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::TestCWLWorkflow::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior
 
 ifdef TOIL_DOCKER_REGISTRY
 
@@ -206,7 +207,7 @@
 
 docker: toil_docker prometheus_docker grafana_docker mtail_docker
 
-toil_docker: docker/Dockerfile
+toil_docker: docker/Dockerfile src/toil/version.py
 	mkdir -p .docker_cache
 	@set -ex \
 	; cd docker \

=== debian/changelog ===
toil (9.0.0-1) unstable; urgency=medium

  * New upstream version.
      Added new unified plugin system.
      Toil now supports URL plugins.
      --importWorkersThreshold has been renamed to --importWorkersBatchsize.
      Fix a bug in Toil server mode CWL YAML parsing.
      CWL worker import works again.
      CWL: Fixed a regression with tmpdir_prefix and nonexistent diectories
      Added --cwl-min-ram to CWL. This specifies a minimum memory allocation
      for all jobs. This is different than --defaultMemory, which only applies
      to jobs without explicitly set memory requirements.
  * Refreshed patches.
  * d/control: needs pytest-httpserver for a new test.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 11 Oct 2025 09:15:28 +0200

## toil 9.1.0

=== Makefile ===
--- 
+++ 
@@ -85,7 +85,8 @@
 
 # This Makefile uses bash features like printf and <()
 SHELL=bash
-tests=src/toil/test
+# We need the default tests to include the doctests, but not htcondor which isn't on mac.
+tests=src/toil --ignore src/toil/batchSystems/htcondor.py
 arch=linux/amd64,linux/arm64
 cov=--cov=toil
 logging=--log-format="%(asctime)s %(levelname)s %(message)s" --log-level DEBUG -o log_cli=true --log-cli-level INFO
@@ -109,7 +110,7 @@
 threads:="auto"
 
 dist:="worksteal"
-pytest_args:=""
+pytest_args:="--randomly-dont-reorganize"
 
 # Only pass the threading options if running parallel tests. Otherwise we lose
 # live logging. See <https://stackoverflow.com/q/62533239>
@@ -169,10 +170,20 @@
 	TOIL_HISTORY=0 \
 	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(cov) $(tests) $(pytest_args)
 
+# When running doctests, we need to not capture output, because on CI we can
+# get failures where doctest saw no output and we report captured output, as in
+# <https://ucsc-ci.com/databiosphere/toil/-/jobs/96131>. doctest and pytest's
+# captures might not work properly together.
+doctest: check_venv check_build_reqs
+	TOIL_OWNER_TAG="shared" \
+	TOIL_HISTORY=0 \
+	    python -m pytest --capture=no $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(cov) $(tests) --ignore src/toil/test $(pytest_args)
+
 test_debug: check_venv check_build_reqs
+	# Don't include threadopts to make sure we can see our live logging.
 	TOIL_OWNER_TAG="$(whoami)" \
 	TOIL_HISTORY=0 \
-	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) $(tests) $(pytest_args) --maxfail=1
+	    python -m pytest $(verbose) $(durations) -m "$(marker)" $(logging) $(tests) $(pytest_args) --maxfail=1
 
 
 # This target will skip building docker and all docker based tests
@@ -189,7 +200,7 @@
 test_1min: check_venv check_build_reqs
 	TOIL_SKIP_DOCKER=False \
 	TOIL_HISTORY=0 \
-	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) --timeout=30  --maxfail=1 $(pytest_args) src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::TestCWLWorkflow::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior
+	    python -m pytest $(verbose) $(durations) $(threadopts) -m "$(marker)" $(logging) --timeout=30 --maxfail=1 $(pytest_args) src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::TestCWLWorkflow::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior
 
 ifdef TOIL_DOCKER_REGISTRY
 
@@ -246,12 +257,3 @@
 	# We need to build from the local cache to the cache tag and again from the local cache to the real tag.
 	cd docker ; \
 	for i in $$(seq 1 6); do \
-		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
-		docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=inline -f Dockerfile . && \
-			docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile . && \
-			break || sleep 60; \
-	done
-	cd dashboard/prometheus ; \
-	for i in $$(seq 1 6); do \
-		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
-		docker buildx build --platform $(arch) --push --tag=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=inline -f Dockerfile . && \

=== requirements.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 dill>=0.3.2, <0.4
-requests<=2.31.0
+requests<=2.32.5
 docker>=6.1.0, <8
 urllib3>=1.26.0,<3
 python-dateutil

=== debian/changelog ===
toil (9.1.0-1) unstable; urgency=medium

  * New upstream version.
      Toil's AWS job store now depends only on the S3 API; Amazon SimpleDB is
        no longer required.
      Toil's autoscaler should again be able to add AWS spot market nodes.
      Toil now checks scontrol first for Slurm jobs, and then pages through
        constrained time ranges of data from sacct, instead of first asking
        sacct about all of history.
      Breaking Changes
        Because of the new AWS job store implementation, Toil 9.1 can no longer
        read, delete, or resume AWS job stores created with Toil 9.0 or
        earlier. If you need to destroy an old job store, use toil clean
        from toil[aws]==9.0. In general, Toil doesn't consider losing
        compatibility with an older Toil's job store data on disk to be a
        major-version-worthy change, since it might happen any time Toil
        revises its internal data structures, but in this case the lack of
        delete support for the old format is a tripping hazard that we want to
        call out.
  * Refreshed patches
  * Cleaned up some lintian warnings
  * New typos for the spelling patch, and forwarded them upstream

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 17 Oct 2025 11:42:07 +0200

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Michael R. Crusoe <crusoe@debian.org>
 Section: net
+Testsuite: autopkgtest-pkg-pybuild
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
@@ -14,12 +15,12 @@
                python3-docker,
                python3-dill,
                cwltool (>= 3.1.20240112164112),
-               python3-schema-salad (>= 8.4.20230128170514),
+               python3-schema-salad,
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
                python3-pytest-xdist <!nocheck>,
-               python3-boto3 (>=1.17) <!nocheck>,
+               python3-boto3 <!nocheck>,
                python3-stubserver <!nocheck>,
                rsync <!nocheck>,
                python3-yaml <!nocheck>,
@@ -37,26 +38,26 @@
                cwltest <!nocheck>,
                python3-pytest-timeout <!nocheck>,
                python3-pytest-subtests <!nocheck>,
-               python3-prompt-toolkit <!nocheck>
+               python3-prompt-toolkit <!nocheck>,
+               python3-pytest-httpserver <!nocheck>,
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
 Rules-Requires-Root: no
-Testsuite: autopkgtest-pkg-pybuild
 
 Package: toil
 Architecture: all
 Depends: ${python3:Depends},
          ${misc:Depends},
          cwltool (>= 3.1.20240112164112),
-         python3-schema-salad (>= 8.4.20230128170514),
+         python3-schema-salad,
          python3-boto3
 Recommends: python3-libcloud
 # for mesos support, but needs python3-mesos first
 #           python3-protobuf,
 Suggests: podman | docker.io | singularity-container | docker-ce,
-          python3-idna,
+          python3-idna
 Provides: cwl-runner
 #Suggests: python-toil-doc
 Description: cross-platform workflow engine

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export PYBUILD_NAME=toil

export PYBUILD_DESTDIR=debian/toil/
PYBUILD_TEST_ARGS=$(DEB_BUILD_OPTION_PARALLEL:%=-n %) --dist loadscope -vv -W ignore  -k "not (testVirtualEnv or DockstoreLookupTest or testMultiplejobs or testServices)" -m "not slow"
# testVirtualEnv - requires an internet connection to download packages from PyPI
# testMultiplejobs - flaky during parallel execution
# testServices - flaky during parallel execution https://bugs.debian.org/1101085
ifeq ($(PYBUILD_AUTOPKGTEST),1)
PYBUILD_TEST_ARGS += --ignore /usr/lib/python3/dist-packages/toil/test/lib/aws/test_s3.py --ignore /usr/lib/python3/dist-packages/toil/test/provisioners/aws/awsProvisionerTest.py --ignore /usr/lib/python3/dist-packages/toil/test/wdl/wdltoil_test.py --ignore /usr/lib/python3/dist-packages/toil/test/cwl/cwlTest.py --ignore /usr/lib/python3/dist-packages/toil/test/lib/test_ec2.py --ignore /usr/lib/python3/dist-packages/toil/test/batchSystems/batchSystemTest.py --ignore /usr/lib/python3/dist-packages/toil/test/lib/aws/test_iam.py --ignore  /usr/lib/python3/dist-packages/toil/test/provisioners/clusterTest.py --ignore /usr/lib/python3/dist-packages/toil/test/wdl/wdltoil_test_kubernetes.py --ignore /usr/lib/python3/dist-packages/toil/test/cactus/test_cactus_integration.py --pyargs toil.test
else
PYBUILD_TEST_ARGS += --ignore toil/test/lib/aws/test_s3.py --ignore toil/test/provisioners/aws/awsProvisionerTest.py --ignore toil/test/wdl/wdltoil_test.py --ignore toil/test/cwl/cwlTest.py --ignore toil/test/lib/test_ec2.py --ignore toil/test/batchSystems/batchSystemTest.py --ignore toil/test/lib/aws/test_iam.py --ignore  toil/test/provisioners/clusterTest.py --ignore toil/test/wdl/wdltoil_test_kubernetes.py --ignore toil/test/cactus/test_cactus_integration.py toil/test
export PYBUILD_AFTER_TEST=find {build_dir} \( -name fileToSort.txt -o -name sortedFile.txt -o -name 'kind-explode_*' \) -print -delete ; find {build_dir} -name "jobstore-test*" | xargs rm -Rf
endif
export PYBUILD_TEST_ARGS

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR)/src http_proxy='127.0.0.1:9' $(MAKE) -C docs man SPHINXOPTS=""
endif
# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#	PYTHONPATH=$(CURDIR)/src http_proxy='127.0.0.1:9' $(MAKE) -C docs html # HTML generator

execute_after_dh_auto_install:
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	TOIL_SKIP_ONLINE=true TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True dh_auto_test
endif

execute_after_dh_auto_clean:
	rm -rf docs/_build
	find . -name "*.pyc" -delete

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,uversionmangle=s/b/~b/g" \
https://github.com/BD2KGenomics/toil/tags .*/releases/@ANY_VERSION@.tar.gz

## toil 9.1.2

=== debian/changelog ===
toil (9.1.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Homepage moved to https://github.com/DataBiosphere/toil
  * d/watch: version=5

  [ Michael R. Crusoe ]
  * Accepted patch to use SubTest from pytest 9.0.1+. Closes: #1123531
  * New upstream version
  * Freshen version patch
  * d/rules: skip testing on Python 3.14 until the next toil release
  * d/control: bump minimum cwltool version, add two suggestions
    (condor, kubernetes)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 08 Jan 2026 09:36:23 +0100

=== debian/control ===
--- 
+++ 
@@ -14,11 +14,11 @@
                python3-configargparse,
                python3-docker,
                python3-dill,
-               cwltool (>= 3.1.20240112164112),
+               cwltool (>= 3.1.20250715140722),
                python3-schema-salad,
                python3-enlighten,
                python3-wdlparse,
-               python3-pytest <!nocheck>,
+               python3-pytest (>= 9.0.1) <!nocheck>,
                python3-pytest-xdist <!nocheck>,
                python3-boto3 <!nocheck>,
                python3-stubserver <!nocheck>,
@@ -33,31 +33,30 @@
                python3-sphinxcontrib.autoprogram <!nodoc>,
                python3-pubsub <!nodoc>,
                python3-doc <!nodoc>,
-               python3-tz <!nodoc> <!nocheck>,
                cwl-utils <!nocheck>,
                cwltest <!nocheck>,
                python3-pytest-timeout <!nocheck>,
-               python3-pytest-subtests <!nocheck>,
                python3-prompt-toolkit <!nocheck>,
-               python3-pytest-httpserver <!nocheck>,
-Standards-Version: 4.7.2
+               python3-pytest-httpserver <!nocheck>
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
-Homepage: https://github.com/BD2KGenomics/toil
-Rules-Requires-Root: no
+Homepage: https://github.com/DataBiosphere/toil
 
 Package: toil
 Architecture: all
 Depends: ${python3:Depends},
          ${misc:Depends},
-         cwltool (>= 3.1.20240112164112),
+         cwltool (>= 3.1.20250715140722),
          python3-schema-salad,
          python3-boto3
 Recommends: python3-libcloud
 # for mesos support, but needs python3-mesos first
 #           python3-protobuf,
 Suggests: podman | docker.io | singularity-container | docker-ce,
-          python3-idna
+          python3-idna,
+          condor,
+          python3-kubernetes
 Provides: cwl-runner
 #Suggests: python-toil-doc
 Description: cross-platform workflow engine

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 export PYBUILD_NAME=toil
 
 export PYBUILD_DESTDIR=debian/toil/
+export PYBUILD_DISABLE_python3.14=test
 PYBUILD_TEST_ARGS=$(DEB_BUILD_OPTION_PARALLEL:%=-n %) --dist loadscope -vv -W ignore  -k "not (testVirtualEnv or DockstoreLookupTest or testMultiplejobs or testServices)" -m "not slow"
 # testVirtualEnv - requires an internet connection to download packages from PyPI
 # testMultiplejobs - flaky during parallel execution

=== debian/watch ===
Version: 5

Source: https://github.com/DataBiosphere/@PACKAGE@/tags
Matching-Pattern: (?:.*?/)?releases/(\d[\d.]+)@ARCHIVE_EXT@
Filename-Mangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
